/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.32 Revision 1.143
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.32 2009/04/23 11:45:38 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.143 2013/03/02 21:44:33 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 3|4|5) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
21 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
22 ;; 37 ;;
23 *) 38 release)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
25 MY_PV="${PV}"
26 ;; 40 ;;
27esac 41esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
45[[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
46
47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
50fi
51
29S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
30 53
31HOMEPAGE="http://www.qtsoftware.com/" 54# @FUNCTION: qt4-build_pkg_setup
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2" 55# @DESCRIPTION:
33 56# Sets up PATH and LD_LIBRARY_PATH.
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
44 # EAPI=2 ebuilds set use-deps, others need this: 58 # Protect users by not allowing downgrades between releases.
45 if [[ $EAPI != 2 ]]; then 59 # Downgrading revisions within the same release should be allowed.
46 # Make sure debug setting corresponds with qt-core (bug 258512) 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
47 if [[ $PN != "qt-core" ]]; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
48 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 62 eerror " *** Sanity check to keep you from breaking your system ***"
49 ~x11-libs/qt-core-${PV} debug" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
64 die "aborting to save your system"
65 else
66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
50 fi 67 fi
51
52 # Check USE requirements
53 qt4-build_check_use
54 fi 68 fi
55 # Set up installation directories
56 QTBASEDIR=/usr/$(get_libdir)/qt4
57 QTPREFIXDIR=/usr
58 QTBINDIR=/usr/bin
59 QTLIBDIR=/usr/$(get_libdir)/qt4
60 QTPCDIR=/usr/$(get_libdir)/pkgconfig
61 QTDATADIR=/usr/share/qt4
62 QTDOCDIR=/usr/share/doc/qt-${PV}
63 QTHEADERDIR=/usr/include/qt4
64 QTPLUGINDIR=${QTLIBDIR}/plugins
65 QTSYSCONFDIR=/etc/qt4
66 QTTRANSDIR=${QTDATADIR}/translations
67 QTEXAMPLESDIR=${QTDATADIR}/examples
68 QTDEMOSDIR=${QTDATADIR}/demos
69 69
70 PLATFORM=$(qt_mkspecs_dir)
71
72 PATH="${S}/bin:${PATH}" 70 PATH="${S}/bin${PATH:+:}${PATH}"
71 if [[ ${CHOST} != *-darwin* ]]; then
73 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
74 73 else
75 if ! version_is_at_least 4.1 $(gcc-version) ; then 74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
76 ewarn "Using a GCC version lower than 4.1 is not supported!" 75 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
77 echo 76 # platform detection. Note: needs to come before any directories to
78 ebeep 3 77 # avoid extract failure.
78 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
80 ${QT4_EXTRACT_DIRECTORIES}"
79 fi 81 fi
80
81 if use custom-cxxflags; then
82 echo
83 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
84 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
85 ewarn "recommend to unset this useflag. But you are free to experiment with it."
86 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
87 ewarn "for breakfast. ;-) "
88 echo
89 fi
90
91} 82}
92 83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
89
90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Arguments for build_target_directories. Takes the directories in which the
94# code should be compiled. This is a space-separated list.
95
96# @FUNCTION: qt4-build_src_unpack
97# @DESCRIPTION:
98# Unpacks the sources.
93qt4-build_src_unpack() { 99qt4-build_src_unpack() {
94 local target targets licenses 100 setqtenv
101
95 if version_is_at_least 4.5 ${PV} ; then 102 if ! version_is_at_least 4.1 $(gcc-version); then
96 licenses="LICENSE.GPL3 LICENSE.LGPL" 103 ewarn "Using a GCC version lower than 4.1 is not supported."
97 else 104 fi
98 licenses="LICENSE.GPL2 LICENSE.GPL3" 105
106 if [[ ${PN} == qt-webkit ]]; then
107 eshopts_push -s extglob
108 if is-flagq '-g?(gdb)?([1-9])'; then
109 echo
110 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
111 ewarn "You may experience really long compilation times and/or increased memory usage."
112 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
113 ewarn "For more info check out https://bugs.gentoo.org/307861"
114 echo
99 fi 115 fi
100 for target in configure ${licenses} projects.pro \ 116 eshopts_pop
117 fi
118
119 case ${QT4_BUILD_TYPE} in
120 live)
121 git-2_src_unpack
122 ;;
123 release)
124 local tarball="${MY_P}.tar.gz" target= targets=
125 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
101 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 126 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
102 ${QT4_EXTRACT_DIRECTORIES}; do 127 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
128 do
103 targets="${targets} ${MY_P}/${target}" 129 targets+="${MY_P}/${target} "
104 done 130 done
105 131
106 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 132 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
107 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 133 tar -xzf "${DISTDIR}/${tarball}" ${targets}
108 134 eend $? || die "failed to unpack"
109 case "${PV}" in
110 4.4.?)
111 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
112 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
113 ;; 135 ;;
114 esac 136 esac
115
116 # Be backwards compatible for now
117 if [[ $EAPI != 2 ]]; then
118 qt4-build_src_prepare
119 fi
120} 137}
121 138
139# @ECLASS-VARIABLE: PATCHES
140# @DEFAULT_UNSET
141# @DESCRIPTION:
142# PATCHES array variable containing all various patches to be applied.
143# This variable is expected to be defined in global scope of ebuild.
144# Make sure to specify the full path. This variable is utilised in
145# src_prepare() phase.
146#
147# @CODE
148# PATCHES=( "${FILESDIR}/mypatch.patch"
149# "${FILESDIR}/patches_folder/" )
150# @CODE
151
152# @FUNCTION: qt4-build_src_prepare
153# @DESCRIPTION:
154# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
155# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
122qt4-build_src_prepare() { 156qt4-build_src_prepare() {
123 cd "${S}" 157 setqtenv
158
159 if [[ ${QT4_BUILD_TYPE} == live ]]; then
160 QTDIR="." ./bin/syncqt || die "syncqt failed"
161 fi
162
163 # avoid X11 dependency in non-gui packages
164 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
165 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
166
167 if use aqua; then
168 # provide a proper macx-g++-64
169 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
170
171 sed -e '/^CONFIG/s:app_bundle::' \
172 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
173 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
174 fi
124 175
125 if [[ ${PN} != qt-core ]]; then 176 if [[ ${PN} != qt-core ]]; then
126 skip_qmake_build_patch 177 skip_qmake_build
127 skip_project_generation_patch 178 skip_project_generation
128 symlink_binaries_to_buildtree 179 symlink_binaries_to_buildtree
129 fi 180 fi
130 181
131 if ! use custom-cxxflags;then 182 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
132 # Don't let the user go too overboard with flags. 183 # qmake bus errors with -O2 or -O3 but -O1 works
133 strip-flags 184 # Bug 373061
134 replace-flags -O3 -O2 185 replace-flags -O[23] -O1
135 fi 186 fi
136 187
137 # Bug 178652 188 # Bug 178652
138 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 189 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
139 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 190 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
140 append-flags -fno-gcse 191 append-flags -fno-gcse
141 fi 192 fi
142 193
194 if use_if_iuse c++0x; then
195 append-cxxflags -std=c++0x
196 fi
197
143 # Unsupported old gcc versions - hardened needs this :( 198 # Unsupported old gcc versions - hardened needs this :(
144 if [[ $(gcc-major-version) -lt "4" ]] ; then 199 if [[ $(gcc-major-version) -lt 4 ]]; then
145 ewarn "Appending -fno-stack-protector to CXXFLAGS" 200 ewarn "Appending -fno-stack-protector to CXXFLAGS"
146 append-cxxflags -fno-stack-protector 201 append-cxxflags -fno-stack-protector
147 # Bug 253127 202 # Bug 253127
148 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 203 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
149 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 204 -i mkspecs/common/g++.conf || die
150 fi 205 fi
206
207 # Bug 261632
208 if use ppc64; then
209 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
210 append-flags -mminimal-toc
211 fi
212
213 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
214 sed -e "/^SYSTEM_VARIABLES=/i \
215 CC='$(tc-getCC)'\n\
216 CXX='$(tc-getCXX)'\n\
217 CFLAGS='${CFLAGS}'\n\
218 CXXFLAGS='${CXXFLAGS}'\n\
219 LDFLAGS='${LDFLAGS}'\n\
220 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
221 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
222 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
223 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
224 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
225 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
226 -i configure \
227 || die "sed SYSTEM_VARIABLES failed"
228
229 # Respect CC, CXX, LINK and *FLAGS in config.tests
230 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
231 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
232 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
233 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
234 || die "sed config.tests failed"
151 235
152 # Bug 172219 236 # Bug 172219
237 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
238
239 if [[ ${CHOST} == *-darwin* ]]; then
240 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
241 # crippled (by design) :/
242 local mac_gpp_conf=
243 if [[ -f mkspecs/common/mac-g++.conf ]]; then
244 # qt < 4.8 has mac-g++.conf
245 mac_gpp_conf="mkspecs/common/mac-g++.conf"
246 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
247 # qt >= 4.8 has g++-macx.conf
248 mac_gpp_conf="mkspecs/common/g++-macx.conf"
249 else
250 die "no known conf file for mac found"
251 fi
252 sed \
153 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 253 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
154 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 254 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
155 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 255 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
156 -e "s:X11R6/::" \ 256 -e "s:-arch\s\w*::g" \
157 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 257 -i ${mac_gpp_conf} \
258 || die "sed ${mac_gpp_conf} failed"
158 259
159 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 260 # Fix configure's -arch settings that appear in qmake/Makefile and also
160 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 261 # fix arch handling (automagically duplicates our -arch arg and breaks
161 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 262 # pch). Additionally disable Xarch support.
162 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 263 local mac_gcc_confs="${mac_gpp_conf}"
264 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
265 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
266 fi
267 sed \
268 -e "s:-arch i386::" \
269 -e "s:-arch ppc::" \
270 -e "s:-arch x86_64::" \
271 -e "s:-arch ppc64::" \
272 -e "s:-arch \$i::" \
273 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
274 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
275 -e "s:-Xarch_x86_64::g" \
276 -e "s:-Xarch_ppc64::g" \
277 -i configure ${mac_gcc_confs} \
278 || die "sed -arch/-Xarch failed"
163 279
164} 280 # On Snow Leopard don't fall back to 10.5 deployment target.
281 if [[ ${CHOST} == *-apple-darwin10 ]]; then
282 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
283 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
284 -i configure ${mac_gpp_conf} \
285 || die "sed deployment target failed"
286 fi
287 fi
165 288
289 # this one is needed for all systems with a separate -liconv, apart from
290 # Darwin, for which the sources already cater for -liconv
291 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
292 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
293 -i config.tests/unix/iconv/iconv.pro \
294 || die "sed iconv.pro failed"
295 fi
296
297 # we need some patches for Solaris
298 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
299 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
300 # use GCC over SunStudio
301 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
302 # do not flirt with non-Prefix stuff, we're quite possessive
303 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
305
306 # apply patches
307 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
308 epatch_user
309}
310
311# @FUNCTION: qt4-build_src_configure
312# @DESCRIPTION:
313# Default configure phase
166qt4-build_src_configure() { 314qt4-build_src_configure() {
315 setqtenv
167 316
168 myconf="$(standard_configure_options) ${myconf}"
169
170 echo ./configure ${myconf}
171 ./configure ${myconf} || die "./configure failed"
172}
173
174qt4-build_src_compile() {
175 # Be backwards compatible for now
176 if [[ $EAPI != 2 ]]; then
177 qt4-build_src_configure
178 fi
179
180 build_directories "${QT4_TARGET_DIRECTORIES}"
181}
182
183qt4-build_src_install() {
184 install_directories "${QT4_TARGET_DIRECTORIES}"
185 install_qconfigs
186 fix_library_files
187}
188
189standard_configure_options() {
190 local myconf="" 317 local conf="
191 318 -prefix ${QTPREFIXDIR}
192 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 319 -bindir ${QTBINDIR}
193 320 -libdir ${QTLIBDIR}
194 # Disable visibility explicitly if gcc version isn't 4 321 -docdir ${QTDOCDIR}
195 if [[ "$(gcc-major-version)" -lt "4" ]]; then 322 -headerdir ${QTHEADERDIR}
196 myconf="${myconf} -no-reduce-exports" 323 -plugindir ${QTPLUGINDIR}
197 fi 324 -importdir ${QTIMPORTDIR}
198 325 -datadir ${QTDATADIR}
199 # precompiled headers doesn't work on hardened, where the flag is masked. 326 -translationdir ${QTTRANSDIR}
200 if use pch; then 327 -sysconfdir ${QTSYSCONFDIR}
201 myconf="${myconf} -pch" 328 -examplesdir ${QTEXAMPLESDIR}
202 else 329 -demosdir ${QTDEMOSDIR}
203 myconf="${myconf} -no-pch" 330 -opensource -confirm-license
204 fi 331 -shared -fast -largefile -stl -verbose
205 332 -nomake examples -nomake demos"
206 if use debug; then
207 myconf="${myconf} -debug -no-separate-debug-info"
208 else
209 myconf="${myconf} -release -no-separate-debug-info"
210 fi
211 333
212 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 334 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
213 # $(tc-arch). Therefore we convert it to supported values. 335 # $(tc-arch). Therefore we convert it to supported values.
214 case "$(tc-arch)" in 336 case "$(tc-arch)" in
215 amd64) myconf="${myconf} -arch x86_64" ;; 337 amd64|x64-*) conf+=" -arch x86_64" ;;
338 ppc-macos) conf+=" -arch ppc" ;;
216 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 339 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
340 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
341 x86-macos) conf+=" -arch x86" ;;
217 x86|x86-*) myconf="${myconf} -arch i386" ;; 342 x86|x86-*) conf+=" -arch i386" ;;
218 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 343 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
219 hppa|sh) myconf="${myconf} -arch generic" ;; 344 hppa|sh) conf+=" -arch generic" ;;
220 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 345 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
221 esac 346 esac
222 347
223 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 348 conf+=" -platform $(qt_mkspecs_dir)"
224 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
225 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
226 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
227 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
228 -demosdir ${QTDEMOSDIR} -silent -fast
229 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
230 -reduce-relocations -nomake examples -nomake demos"
231
232 # Make eclass 4.5.{1,2} ready
233 case "${MY_PV}" in
234 4.5.1 | 4.5.2)
235 myconf="${myconf} -opensource"
236 ;;
237 esac
238 349
350 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
351
352 # debug/release
353 if use debug; then
354 conf+=" -debug"
355 else
356 conf+=" -release"
357 fi
358 conf+=" -no-separate-debug-info"
359
360 # exceptions USE flag
361 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
362
363 # disable rpath (bug 380415), except on prefix (bug 417169)
364 use prefix || conf+=" -no-rpath"
365
366 # precompiled headers don't work on hardened, where the flag is masked
367 conf+=" $(qt_use pch)"
368
369 # -reduce-relocations
370 # This flag seems to introduce major breakage to applications,
371 # mostly to be seen as a core dump with the message "QPixmap: Must
372 # construct a QApplication before a QPaintDevice" on Solaris.
373 # -- Daniel Vergien
374 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
375
376 # this one is needed for all systems with a separate -liconv, apart from
377 # Darwin, for which the sources already cater for -liconv
378 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
379 conf+=" -liconv"
380 fi
381
382 if use_if_iuse glib; then
383 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
384 # avoid the -pthread argument
385 conf+=" ${glibflags//-pthread}"
386 unset glibflags
387 fi
388
389 if use aqua; then
390 # On (snow) leopard use the new (frameworked) cocoa code.
391 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
392 conf+=" -cocoa -framework"
393 # We need the source's headers, not the installed ones.
394 conf+=" -I${S}/include"
395 # Add hint for the framework location.
396 conf+=" -F${QTLIBDIR}"
397
398 # We are crazy and build cocoa + qt3support :-)
399 if use qt3support; then
400 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
401 -i configure || die
402 fi
403 else
404 conf+=" -no-framework"
405 fi
406 else
407 # freetype2 include dir is non-standard, thus pass it to configure
408 conf+=" $(pkg-config --cflags-only-I freetype2)"
409 fi
410
239 echo "${myconf}" 411 conf+=" ${myconf}"
240} 412 myconf=
241 413
414 echo ./configure ${conf}
415 ./configure ${conf} || die "./configure failed"
416
417 prepare_directories ${QT4_TARGET_DIRECTORIES}
418}
419
420# @FUNCTION: qt4-build_src_compile
421# @DESCRIPTION:
422# Actual compile phase
423qt4-build_src_compile() {
424 setqtenv
425
426 build_directories ${QT4_TARGET_DIRECTORIES}
427}
428
429# @FUNCTION: qt4-build_src_test
430# @DESCRIPTION:
431# Runs tests only in target directories.
432qt4-build_src_test() {
433 # QtMultimedia does not have any test suite (bug #332299)
434 [[ ${PN} == qt-multimedia ]] && return
435
436 for dir in ${QT4_TARGET_DIRECTORIES}; do
437 emake -j1 check -C ${dir}
438 done
439}
440
441# @FUNCTION: fix_includes
442# @DESCRIPTION:
443# For MacOS X we need to add some symlinks when frameworks are
444# being used, to avoid complications with some more or less stupid packages.
445fix_includes() {
446 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
447 local frw dest f h rdir
448 # Some packages tend to include <Qt/...>
449 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
450
451 # Fake normal headers when frameworks are installed... eases life later
452 # on, make sure we use relative links though, as some ebuilds assume
453 # these dirs exist in src_install to add additional files
454 f=${QTHEADERDIR}
455 h=${QTLIBDIR}
456 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
457 f=${f#*/}
458 h=${h#*/}
459 done
460 rdir=${h}
461 f="../"
462 while [[ ${h} == */* ]] ; do
463 f="${f}../"
464 h=${h#*/}
465 done
466 rdir="${f}${rdir}"
467
468 for frw in "${D}${QTLIBDIR}"/*.framework; do
469 [[ -e "${frw}"/Headers ]] || continue
470 f=$(basename ${frw})
471 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
472 dosym "${rdir}"/${f}/Headers "${dest}"
473
474 # Link normal headers as well.
475 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
476 h=$(basename ${hdr})
477 dosym "../${rdir}"/${f}/Headers/${h} \
478 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
479 done
480 done
481 fi
482}
483
484# @FUNCTION: qt4-build_src_install
485# @DESCRIPTION:
486# Perform the actual installation including some library fixes.
487qt4-build_src_install() {
488 setqtenv
489
490 install_directories ${QT4_TARGET_DIRECTORIES}
491 install_qconfigs
492 fix_library_files
493 fix_includes
494
495 # remove .la files since we are building only shared libraries
496 prune_libtool_files
497}
498
499# @FUNCTION: setqtenv
500# @INTERNAL
501setqtenv() {
502 # Set up installation directories
503 QTPREFIXDIR=${EPREFIX}/usr
504 QTBINDIR=${QTPREFIXDIR}/bin
505 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
506 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
507 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
508 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
509 QTPLUGINDIR=${QTLIBDIR}/plugins
510 QTIMPORTDIR=${QTLIBDIR}/imports
511 QTDATADIR=${QTPREFIXDIR}/share/qt4
512 QTTRANSDIR=${QTDATADIR}/translations
513 QTSYSCONFDIR=${EPREFIX}/etc/qt4
514 QTEXAMPLESDIR=${QTDATADIR}/examples
515 QTDEMOSDIR=${QTDATADIR}/demos
516 QMAKE_LIBDIR_QT=${QTLIBDIR}
517
518 PLATFORM=$(qt_mkspecs_dir)
519 unset QMAKESPEC
520
521 export XDG_CONFIG_HOME="${T}"
522}
523
524# @FUNCTION: prepare_directories
525# @USAGE: < directories >
526# @INTERNAL
527# @DESCRIPTION:
528# Generates Makefiles for the given list of directories.
529prepare_directories() {
530 # avoid running over the maximum argument number, bug #299810
531 {
532 echo "${S}"/mkspecs/common/*.conf
533 find "${S}" -name '*.pr[io]'
534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
538
539 for x in "$@"; do
540 pushd "${S}"/${x} >/dev/null || die
541 einfo "Running qmake in: ${x}"
542 "${S}"/bin/qmake \
543 "LIBS+=-L${QTLIBDIR}" \
544 "CONFIG+=nostrip" \
545 || die "qmake failed"
546 popd >/dev/null || die
547 done
548}
549
550# @FUNCTION: build_directories
551# @USAGE: < directories >
552# @INTERNAL
553# @DESCRIPTION:
554# Compiles the code in the given list of directories.
242build_directories() { 555build_directories() {
243 local dirs="$@"
244 for x in ${dirs}; do 556 for x in "$@"; do
245 cd "${S}"/${x} 557 pushd "${S}"/${x} >/dev/null || die
246 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 558 emake \
559 AR="$(tc-getAR) cqs" \
560 CC="$(tc-getCC)" \
561 CXX="$(tc-getCXX)" \
562 LINK="$(tc-getCXX)" \
563 RANLIB=":" \
564 STRIP=":" \
247 emake || die "emake failed" 565 || die "emake failed"
566 popd >/dev/null || die
248 done 567 done
249} 568}
250 569
570# @FUNCTION: install_directories
571# @USAGE: < directories >
572# @INTERNAL
573# @DESCRIPTION:
574# Runs emake install in the given directories, which are separated by spaces.
251install_directories() { 575install_directories() {
252 local dirs="$@"
253 for x in ${dirs}; do 576 for x in "$@"; do
254 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 577 pushd "${S}"/${x} >/dev/null || die
255 emake INSTALL_ROOT="${D}" install || die "emake install failed" 578 emake INSTALL_ROOT="${D}" install || die "emake install failed"
256 popd >/dev/null || die "Can't popd from ${S}/${x}" 579 popd >/dev/null || die
257 done 580 done
258} 581}
259 582
260# @ECLASS-VARIABLE: QCONFIG_ADD 583# @ECLASS-VARIABLE: QCONFIG_ADD
261# @DESCRIPTION: 584# @DESCRIPTION:
262# List options that need to be added to QT_CONFIG in qconfig.pri 585# List options that need to be added to QT_CONFIG in qconfig.pri
263QCONFIG_ADD="${QCONFIG_ADD:-}" 586: ${QCONFIG_ADD:=}
264 587
265# @ECLASS-VARIABLE: QCONFIG_REMOVE 588# @ECLASS-VARIABLE: QCONFIG_REMOVE
266# @DESCRIPTION: 589# @DESCRIPTION:
267# List options that need to be removed from QT_CONFIG in qconfig.pri 590# List options that need to be removed from QT_CONFIG in qconfig.pri
268QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 591: ${QCONFIG_REMOVE:=}
269 592
270# @ECLASS-VARIABLE: QCONFIG_DEFINE 593# @ECLASS-VARIABLE: QCONFIG_DEFINE
271# @DESCRIPTION: 594# @DESCRIPTION:
272# List variables that should be defined at the top of QtCore/qconfig.h 595# List variables that should be defined at the top of QtCore/qconfig.h
273QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 596: ${QCONFIG_DEFINE:=}
274 597
598# @FUNCTION: install_qconfigs
599# @INTERNAL
600# @DESCRIPTION:
601# Install gentoo-specific mkspecs configurations.
275install_qconfigs() { 602install_qconfigs() {
276 local x 603 local x
277 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 604 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
278 for x in QCONFIG_ADD QCONFIG_REMOVE; do 605 for x in QCONFIG_ADD QCONFIG_REMOVE; do
279 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 606 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
280 done 607 done
281 insinto ${QTDATADIR}/mkspecs/gentoo 608 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
282 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 609 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
283 fi 610 fi
284 611
285 if [[ -n ${QCONFIG_DEFINE} ]]; then 612 if [[ -n ${QCONFIG_DEFINE} ]]; then
286 for x in ${QCONFIG_DEFINE}; do 613 for x in ${QCONFIG_DEFINE}; do
287 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 614 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
288 done 615 done
289 insinto ${QTHEADERDIR}/Gentoo 616 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
290 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 617 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
291 fi 618 fi
292} 619}
293 620
621# @FUNCTION: generate_qconfigs
622# @INTERNAL
623# @DESCRIPTION:
624# Generates gentoo-specific qconfig.{h,pri}.
294generate_qconfigs() { 625generate_qconfigs() {
295 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 626 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
296 local x qconfig_add qconfig_remove qconfig_new 627 local x qconfig_add qconfig_remove qconfig_new
297 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 628 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
298 [[ -f ${x} ]] || continue 629 [[ -f ${x} ]] || continue
299 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 630 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
300 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 631 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
301 done 632 done
302 633
303 # these error checks do not use die because dying in pkg_post{inst,rm} 634 # these error checks do not use die because dying in pkg_post{inst,rm}
304 # just makes things worse. 635 # just makes things worse.
305 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 636 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
312 643
313 # generate list of QT_CONFIG entries from the existing list 644 # generate list of QT_CONFIG entries from the existing list
314 # including qconfig_add and excluding qconfig_remove 645 # including qconfig_add and excluding qconfig_remove
315 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 646 for x in $(sed -n 's/^QT_CONFIG +=//p' \
316 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 647 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
317 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 648 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
318 done 649 done
319 650
320 # replace the existing QT_CONFIG list with qconfig_new 651 # replace the existing QT_CONFIG list with qconfig_new
321 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 652 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
322 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 653 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
345 "${ROOT}${QTHEADERDIR}" 2>/dev/null 676 "${ROOT}${QTHEADERDIR}" 2>/dev/null
346 fi 677 fi
347 fi 678 fi
348} 679}
349 680
681# @FUNCTION: qt4-build_pkg_postrm
682# @DESCRIPTION:
683# Regenerate configuration when the package is completely removed.
350qt4-build_pkg_postrm() { 684qt4-build_pkg_postrm() {
351 generate_qconfigs 685 generate_qconfigs
352} 686}
353 687
688# @FUNCTION: qt4-build_pkg_postinst
689# @DESCRIPTION:
690# Regenerate configuration, plus throw a message about possible
691# breakages and proposed solutions.
354qt4-build_pkg_postinst() { 692qt4-build_pkg_postinst() {
355 generate_qconfigs 693 generate_qconfigs
356 echo
357 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
358 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
359 ewarn "should recompile the packages providing these plugins. Also, make sure you"
360 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
361 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
362 ewarn
363 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
364 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
365 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
366 ewarn "configuration."
367 ewarn
368 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
369 echo
370} 694}
371 695
696# @FUNCTION: skip_qmake_build
697# @INTERNAL
698# @DESCRIPTION:
699# Patches configure to skip qmake compilation, as it's already installed by qt-core.
372skip_qmake_build_patch() { 700skip_qmake_build() {
373 # Don't need to build qmake, as it's already installed from qt-core
374 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 701 sed -i -e "s:if true:if false:g" "${S}"/configure || die
375} 702}
376 703
377skip_project_generation_patch() { 704# @FUNCTION: skip_project_generation
705# @INTERNAL
706# @DESCRIPTION:
378 # Exit the script early by throwing in an exit before all of the .pro files are scanned 707# Exit the script early by throwing in an exit before all of the .pro files are scanned.
708skip_project_generation() {
379 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 709 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
380 -i "${S}"/configure || die "Sed failed"
381} 710}
382 711
712# @FUNCTION: symlink_binaries_to_buildtree
713# @INTERNAL
714# @DESCRIPTION:
715# Symlinks generated binaries to buildtree, so they can be used during compilation time.
383symlink_binaries_to_buildtree() { 716symlink_binaries_to_buildtree() {
384 for bin in qmake moc uic rcc; do 717 for bin in qmake moc uic rcc; do
385 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 718 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
386 done 719 done
387} 720}
388 721
722# @FUNCTION: fix_library_files
723# @INTERNAL
724# @DESCRIPTION:
725# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
726# moves the *.pc files into the pkgconfig directory.
389fix_library_files() { 727fix_library_files() {
728 local libfile
390 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 729 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
391 if [[ -e ${libfile} ]]; then 730 if [[ -e ${libfile} ]]; then
392 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 731 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
393 fi 732 fi
394 done 733 done
395 734
396 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 735 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
397 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 736 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
398 if [[ -e ${libfile} ]]; then 737 if [[ -e ${libfile} ]]; then
399 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 738 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
400 739
401 # Move .pc files into the pkgconfig directory 740 # Move .pc files into the pkgconfig directory
402
403 dodir ${QTPCDIR} 741 dodir ${QTPCDIR#${EPREFIX}}
404 mv ${libfile} "${D}"/${QTPCDIR}/ \ 742 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
405 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
406 fi 743 fi
407 done 744 done
408 745
409 # Don't install an empty directory 746 # Don't install an empty directory
410 rmdir "${D}"/${QTLIBDIR}/pkgconfig 747 rmdir "${D}"/${QTLIBDIR}/pkgconfig
411} 748}
412 749
750# @FUNCTION: qt_use
751# @USAGE: < flag > [ feature ] [ enableval ]
752# @DESCRIPTION:
753# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
754# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
755# will be used for that. If [enableval] is not specified, it omits the
756# "-${enableval}" part.
413qt_use() { 757qt_use() {
414 local flag="${1}" 758 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
415 local feature="${1}"
416 local enableval=
417
418 [[ -n ${2} ]] && feature=${2}
419 [[ -n ${3} ]] && enableval="-${3}"
420
421 if use ${flag}; then
422 echo "${enableval}-${feature}"
423 else
424 echo "-no-${feature}"
425 fi
426} 759}
427 760
428# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 761# @FUNCTION: qt_mkspecs_dir
762# @RETURN: the specs-directory w/o path
429# @DESCRIPTION: 763# @DESCRIPTION:
430# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 764# Allows us to define which mkspecs dir we want to use.
431# (eutils.eclass), line per line.
432#
433# Example:
434# @CODE
435# pkg_setup() {
436# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
437# ~x11-libs/qt-gui-${PV} qt3support"
438# qt4-build_check_use
439# }
440# @CODE
441
442# Run built_with_use on each flag and print appropriate error messages if any
443# flags are missing
444_qt_built_with_use() {
445 local missing opt pkg flag flags
446
447 if [[ ${1} = "--missing" ]]; then
448 missing="${1} ${2}" && shift 2
449 fi
450 if [[ ${1:0:1} = "-" ]]; then
451 opt=${1} && shift
452 fi
453
454 pkg=${1} && shift
455
456 for flag in "${@}"; do
457 flags="${flags} ${flag}"
458 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
459 flags="${flags}*"
460 else
461 [[ ${opt} = "-o" ]] && return 0
462 fi
463 done
464 if [[ "${flags# }" = "${@}" ]]; then
465 return 0
466 fi
467 if [[ ${opt} = "-o" ]]; then
468 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
469 else
470 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
471 fi
472 return 1
473}
474
475# @FUNCTION: qt4-build_check_use
476# @DESCRIPTION:
477# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
478# USE flags listed.
479#
480# If any of the required USE flags are missing, an eerror will be printed for
481# each package with missing USE flags.
482qt4-build_check_use() {
483 local line missing
484 while read line; do
485 [[ -z ${line} ]] && continue
486 if ! _qt_built_with_use ${line}; then
487 missing=true
488 fi
489 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
490 if [[ -n ${missing} ]]; then
491 echo
492 eerror "Flags marked with an * are missing."
493 die "Missing USE flags found"
494 fi
495}
496
497qt_mkspecs_dir() { 765qt_mkspecs_dir() {
498 # Allows us to define which mkspecs dir we want to use.
499 local spec 766 local spec=
500 767
501 case ${CHOST} in 768 case "${CHOST}" in
502 *-freebsd*|*-dragonfly*) 769 *-freebsd*|*-dragonfly*)
503 spec="freebsd" ;; 770 spec=freebsd ;;
504 *-openbsd*) 771 *-openbsd*)
505 spec="openbsd" ;; 772 spec=openbsd ;;
506 *-netbsd*) 773 *-netbsd*)
507 spec="netbsd" ;; 774 spec=netbsd ;;
508 *-darwin*) 775 *-darwin*)
776 if use aqua; then
777 # mac with carbon/cocoa
778 spec=macx
779 else
780 # darwin/mac with x11
509 spec="darwin" ;; 781 spec=darwin
782 fi
783 ;;
784 *-solaris*)
785 spec=solaris ;;
510 *-linux-*|*-linux) 786 *-linux-*|*-linux)
511 spec="linux" ;; 787 spec=linux ;;
512 *) 788 *)
513 die "Unknown CHOST, no platform choosen." 789 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
514 esac 790 esac
515 791
516 CXX=$(tc-getCXX) 792 case "$(tc-getCXX)" in
517 if [[ ${CXX/g++/} != ${CXX} ]]; then 793 *g++*)
518 spec="${spec}-g++" 794 spec+=-g++ ;;
519 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 795 *icpc*)
520 spec="${spec}-icc" 796 spec+=-icc ;;
521 else 797 *)
522 die "Unknown compiler ${CXX}." 798 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
799 esac
800
801 # Add -64 for 64bit profiles
802 if use x64-freebsd ||
803 use amd64-linux ||
804 use x64-macos ||
805 use x64-solaris ||
806 use sparc64-solaris
807 then
808 spec+=-64
523 fi 809 fi
524 810
525 echo "${spec}" 811 echo "${spec}"
526} 812}
527 813
528case ${EAPI:-0} in 814# @FUNCTION: qt_nolibx11
529 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 815# @INTERNAL
816# @DESCRIPTION:
817# Ignore X11 tests for packages that don't need X libraries installed.
818qt_nolibx11() {
819 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
820 die "x11 check sed failed"
821}
822
530 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 823EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
531esac

Legend:
Removed from v.1.32  
changed lines
  Added in v.1.143

  ViewVC Help
Powered by ViewVC 1.1.20